import gzip
import xml.etree.ElementTree as ET
import os

def process_file(fn, d, s):
    try:
        f = gzip.GzipFile(fn, "r")
        f.read(1)
        f.seek(0)
    except:
        f = open(fn, "r")
    try:
        obj = ET.parse(f)
    except:
        f.seek(0)
        f.readline()
        f.readline()
        try:
            obj = ET.parse(f)
        except:
            print(fn)
            return
    try:
        model = obj.find("cpu-model").text
        mhz = obj.find("cpu-mhz").text
        current_time = [0, 0]
        for el in obj.findall("tests/test"):
            status = el.attrib["status"]
            time = int(el.attrib["time"])
            if status in s:
                current_time[0] += time
            elif status in ["TL"]:
                current_time[1] += time

        if (model, mhz) not in d:
            d[(model, mhz)] = [0, 0]
        for i in range(2):
            d[(model, mhz)][i] += current_time[i]
    except:
        pass

def process_path(path, d, s):
    for entry in os.walk(path):
        prefix = entry[0]
        for file_name in entry[2]:
            process_file(os.path.join(prefix,file_name), d, s)

path = input()

for s in [["OK", "WA", "PE", "RE"], ["OK", "WA", "PE", "RE", "RT"]]:
    d = dict()
    process_path(path, d, s)
    for k in d:
        # print("\"{}\" {} {} {}".format(k[0],k[1],d[k][0],d[k][1]))
        print(d[k][0],d[k][1])
