#include "testlib.h"
#include <string>
#include <set>
#include <vector>
#include <iostream>
using namespace std;

set<pair<int,int>> bad;

struct graph {
    int n;
    vector<vector<int>> g;

    void addEdge(int u, int v) {
        if (bad.count({u, v}) > 0 || bad.count({v, u}) > 0) {
            return;
        }    
        g[u].push_back(v);
        g[v].push_back(u);
    }
};

graph g;

void dfs(int u, vector<int> &used) {
    if (used[u]) {
        return;
    }
    used[u] = 1;

    for (auto v : g.g[u]) {
        dfs(v, used);
    }
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);

    g.n = inf.readInt();
    vector<int> kr(inf.readInt());
    for (size_t i = 0; i < kr.size(); ++i) {
        kr[i] = inf.readInt();
    }

    vector<int> fi(inf.readInt());
    for (int i = 0; i < fi.size(); ++i) {
        fi[i] = inf.readInt();
    }

    g.g.resize(6 * g.n * g.n + 1);

    int wall_cnt = ouf.readInt();
    int corr_cnt = ans.readInt();

    if (wall_cnt > corr_cnt) {
        quitf(_wa, "%d instead %d", wall_cnt, corr_cnt);
    }

    for (int i = 0; i < wall_cnt; ++i) {
        int u = ouf.readInt();
        int v = ouf.readInt();
        bad.insert(make_pair(u, v));
    } 

    int idx = 0;
    for (int i = 0; i < g.n; ++i) {
        int layerCnt = 2 * g.n + 1 + 2 * i;
        for (int j = 0; j < layerCnt; ++j) {
            int cur = ++idx;
            if (j != 0) {
                g.addEdge(cur, cur - 1);
            }
            if (j % 2 == 1 && cur - layerCnt + 1 > 0) {
                g.addEdge(cur, cur - layerCnt + 1);
            }
        }
    }
    for (int i = 0; i < g.n; ++i) {
        int layerCnt = 4 * g.n - 1 - 2 * i;
        for (int j = 0; j < layerCnt; ++j) {
            int cur = ++idx;
            if (j != 0) {
                g.addEdge(cur, cur - 1);
            }
            if (i > 0) {
                if (j % 2 == 0 && cur - layerCnt - 1 > 0) {
                    g.addEdge(cur, cur - layerCnt - 1);
                }
            } else {
                if (j % 2 == 0 && cur - layerCnt > 0) {
                    g.addEdge(cur, cur - layerCnt);
                }                
            }
        }
    }

    vector<int> used(6 * g.n * g.n + 1);

    for (auto u : kr) {
        dfs(u, used);
    }  

    for (auto u : fi) {
        if (used[u]) {
            quitf(_wa, "fix %d was attacked", u);
        }
    }

    if (wall_cnt < corr_cnt) {
        quitf(_fail, "%d instead %d", wall_cnt, corr_cnt);
    }

    quitf(_ok, "solution is correct");

    return 0;
}
