#include "testlib.h"
#include <string>
#include <set>
#include <iostream>

using std::string;
using std::to_string;

using namespace std;

int digit_root(string s) {
    if (s.size() == 1) {
        return s[0] - '0';
    }
    int sum = 0;
    for (auto c : s) {
        sum += c - '0';
    }
    return digit_root(to_string(sum));
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);

    set<string> input_set;
    int n = inf.readInt();
    inf.nextLine();
    for (int i = 0; i < n; ++i) {
        auto s = inf.readString();
        input_set.insert(s);
    }

    int m = inf.readInt();
    inf.nextLine();
    int cnt_FY = 0, cnt_yes_total = 0, cnt_no_total = 0, cnt_N = 0;
    for (int i = 0; i < m; ++i) {
        auto s = inf.readString();
        auto status = ouf.readString();

        if (input_set.count(s) > 0) {
            ++cnt_yes_total;
        } else {
            ++cnt_no_total;
        }

        if (status == "YES") {
            if (input_set.count(s) == 0) {
                ++cnt_FY;
            }
        } else if (status == "NO") {
            if (input_set.count(s) > 0) {
                cout << 0 << endl;
                quit(_wa, "NO while exists");
            }
            ++cnt_N;
        } else {
            quit(_pe, "YES/NO expected");
        }
    }

    cerr << "Total Yes " << cnt_yes_total << endl;
    cerr << "Total No" << cnt_no_total << endl;
    cerr << "Total Fail(Y) " << cnt_FY << endl;
    cerr << "Total NO " << cnt_N << endl;

    if (cnt_N == 0) { 
        cout << 0 <<endl;
        quit(_wa, "no 'NO'");
    }

    cout << 6 + min(4, int(10 * (1 - (cnt_no_total - cnt_N * 1.0) / cnt_no_total))) << endl;
    quitf(_wa, "solution is correct");

    return 0;
}
