/* -*- mode: c++; c-basic-offset: 4 -*- */

#include <iostream>
#include <string>
#include <sstream>
#include <random>
#include <vector>
#include <cstdint>
#include <cstdlib>
#include <algorithm>

using namespace std;

random_device rnd_dev;
mt19937 random_gen;

char tochar(int n)
{
    if (n == 0) {
        return 'A';
    } else if (n == 1) {
        return 'G';
    } else if (n == 2) {
        return 'U';
    } else if (n == 3) {
        return 'C';
    } else {
        abort();
    }
}

int main(int argc, char *argv[])
{
    int m = strtol(argv[1], NULL, 10);
    int l = strtol(argv[2], NULL, 10);
    int n = strtol(argv[3], NULL, 10);
    int seed = strtol(argv[4], NULL, 10);

    random_gen.seed(seed);
    vector<string> ss(n);
    for (int i = 0; i < 1; ++i) {
        ss[i].resize(m);
        for (int j = 0; j < m; ++j) {
            ss[i][j] = tochar(random_gen() % 4);
        }
    }
    ss[1] = ss[0];
    for (int i = 2; i < n; ++i) {
        ss[i].resize(m);
        for (int j = 0; j < m; j += l) {
            int index = random_gen() % 2;
            copy(ss[index].begin() + j, ss[index].begin() + j + l, ss[i].begin() + j);
        }
    }

    cout << m << " " << l << " " << n << endl;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << ss[j][i];
        }
        cout << endl;
    }
}
